package es.us.ccia.dummy.dibujo;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;

import javax.swing.*;
import javax.swing.event.* ;

import es.us.ccia.contexto.*;
import es.us.ccia.contexto.elementos.FCAAttribute;
import es.us.ccia.dummy.contexto.entsal.*;
import es.us.ccia.dummy.dibujo.ventanas.*;
import es.us.ccia.dummy.teoria.regiones.ListaElementos;
import es.us.ccia.razonador.Razonador;
import es.us.ccia.rcc.RCC;
import es.us.tad.Ficheros;
import es.us.tad.Salida;



@SuppressWarnings({"serial","unchecked"})
public abstract class GUI extends JFrame 
	implements SwingConstants, I_Constantes
		//, ChangeListener
		//, ListSelectionListener 
		
		{
    
	public VentanaEtiquetas getVetiq() {
		return vetiq;
	}

	public VentanaObjetos getVindiv() {
		return vindiv;
	}

	public VentanaRelaciones getVrel() {
		return vrel;
	}


	private int TipoAplicacion;
	
	private Container cliente;

	private JSplitPane Izquierdo;
	private VentanaEtiquetas vetiq;
	private VentanaObjetos   vindiv;

	private JPanel Derecho;
//	private VentanaBoton      vboton;
	private VentanaHistorial  vhist;
	private VentanaRelaciones vrel;
	private VentanaDibujo     vdibujo;

	private VentanaReticulo   vreticulo;
	
	
	
	private BarraIconos biconos;
	private BarraMenu barraMenu;

	ActionListener al  = null;
  
	public GUI(String Titulo, int _tipoAplic) {
		super( Titulo );
		
		TipoAplicacion  = _tipoAplic;
		
		// Se habilitan los eventos
		enableEvents( AWTEvent.WINDOW_EVENT_MASK );
		
    	al = new ActionListener(){
    		public void actionPerformed(ActionEvent e) {
    			String clase = e.getSource().getClass().getSimpleName();
    			String comando = e.getActionCommand();
    			
    			System.out.println("he recibido evento");
    			System.out.println(clase + " - " + comando);
    			
    			
//    			if (clase.equalsIgnoreCase("JMenuItem")) {
    				if (comando.equalsIgnoreCase("Open")) {
    					menuAbrir();
    				} else if (comando.equalsIgnoreCase("Exit")) {
    					menuSalir();
    				} else if (comando.equalsIgnoreCase("Save")) {
    					menuGuardarComo();
    					
    				} else if (comando.equalsIgnoreCase("Save as")) {
    					menuGuardarComo();
    					
    				} else if (comando.equalsIgnoreCase("Import Delic")) {
    					menuImportarDel();
    					
    				} else if (comando.equalsIgnoreCase("Export Delic")) {
    					menuExportarDel();

    				} else if (comando.equalsIgnoreCase("New")) {
    					menuNuevo();

    				} else if (comando.equalsIgnoreCase("About")) {
    					menuAcercade();

    				} else if (comando.equalsIgnoreCase("Undo")) {
    					menuDeshacer();
    				
    				} else if (comando.equalsIgnoreCase("Apply")) {
    					botonEjecutarCambios(vdibujo.getListaElementos());
    					
    				} else if (comando.equalsIgnoreCase("Suggest")) {
    					Salida.Imprimirln("Esto es para sugerir");
    					biconos.cambiarSugerencias();
    					
    				} else {
    					Salida.Imprimirln(comando);
    					Salida.Imprimirln("Opcion del menu no implementada");
    				}

//    			} else if (clase.equalsIgnoreCase("JButton")) {
//    				Salida.Imprimirln("He pulsado un boton!!");
//    				if (comando.equalsIgnoreCase("S A V E !")) {
//    					botonEjecutarCambios(vdibujo.getListaElementos());
//    				}
//    			} else  {
//        			System.out.println(" no implementado ");
//    			}
    		}
    		
    	};
		
	}
    
    
    
    public void init() {

    	
    	// Barra de MENU
    	barraMenu  = new BarraMenu(al);
    	setJMenuBar( barraMenu );

    	// Barra de Iconos
    	biconos = new BarraIconos(al,TipoAplicacion);
    	biconos.setVisible(true);
    	biconos.setSugerencias(false);
    	
    	
    	//  Ventana de la Izquierda    //
    	vetiq = new VentanaEtiquetas(this);
    	vindiv = new VentanaObjetos(this);
    
    	Izquierdo = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
    	Izquierdo.add(vetiq);
    	Izquierdo.add(vindiv);
    	Izquierdo.setPreferredSize(new Dimension(250,800));
    
    	//  Ventanas de la Derecha
//    	vboton = new VentanaBoton(al);
    	vreticulo = new VentanaReticulo(this);
    	
    	
    	
    	
    	vrel   = new VentanaRelaciones(this);
    	vhist  = new VentanaHistorial();
    	Derecho = new JPanel();
    	if (TipoAplicacion == TINY) {    		
    		Derecho.setLayout( new GridLayout(3,1) );
    		Derecho.add(vreticulo);
    	} else {
    		Derecho.setLayout( new GridLayout(2,1) );    		
    	}
    		
    		
//    	Derecho.add(vboton);

    	
    	Derecho.add(vrel);
    	Derecho.add(vhist);


    	// 	Panel Central
    	vdibujo = new VentanaDibujo(this);
  
    
    	// COMPOSICION PANTALLA
    	cliente = this.getContentPane();
    	cliente.setLayout( new BorderLayout() );
    	cliente.add( biconos,BorderLayout.NORTH);
    	cliente.add( Izquierdo,BorderLayout.LINE_START);
    	cliente.add( vdibujo, BorderLayout.CENTER );
    	cliente.add( Derecho,BorderLayout.LINE_END );
    
    }
    
    
    public void stateChanged( ChangeEvent ce ) {
    }
    
    
    public void processEvent( AWTEvent evt ) {
    	if( evt.getID() == WindowEvent.WINDOW_CLOSING ) {
    		System.exit( 0 );
    	} else {
    		super.processEvent( evt );
    	}
    }

  //==============================================================
  //==============================================================
  //==============================================================
  //==============================================================
  //==============================================================
    
    /**
     * Aqui hay que implementar el undo.
     */
    public void menuDeshacer() {

    	System.out.println("UNDO not implemented");
//    	vdibujo.deshacer();

    }
    
    
	/**
	 * 
	 */
	public void menuSalir() {
		
		// Abria que comprobar que no se ha modificado nada...
		// por si se quiere grabar.. 
		int res = JOptionPane.showConfirmDialog( null,
				"You are going to leave Paella,\n\n Are you SURE?\n\n",
				"Confirmation - Paella.",JOptionPane.YES_NO_OPTION );
				   
		if( res == JOptionPane.YES_OPTION ) { 
			System.exit(0);
			
		} else {
			//respuesta = "No";
		}
				    
		
	}
	
	
	
	
	
	
	/**
	 * Open the context file.
	 */
	public void menuAbrir() {	

		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File("."));
			
		int retVal = fileChooser.showOpenDialog(this);
		if (retVal == JFileChooser.APPROVE_OPTION) {
			String fileName = fileChooser.getSelectedFile().getAbsolutePath();
			String extension = fileName.substring(fileName.lastIndexOf(".")+1, fileName.length());
			
			try {
				Ficheros f = new Ficheros(fileName);
				String contenido = f.LeerFichero();
				
				// Esto lo carga en el contexto
				if (extension.equalsIgnoreCase("txt")) {
					Entrada.analizarContenidoTXT(contenido);
					
					
				} else if (extension.equalsIgnoreCase("cxt")) {
					Entrada.analizarContenidoCXT(contenido);
					
					
				} else {

				}
				
				
				
				Razonador.inicializar(RCC.DummyRCC5,null);
//				reiniciarContexto(
//						Contexto.getAttributes(),Contexto.getObjects());
				reiniciarContexto();
			} catch (Exception ioe) {
				Salida.Imprimirln("ERROR AL LEER EL FICHERO DE CONTEXTO");
				ioe.printStackTrace();
			}
		}
 
	
	}

	public void menuImportarDel() {
		
		Salida.Imprimirln("OPCION DE IMPORTAR");
		Salida.Imprimirln("--Empieza a importar");

		Contexto.inicializar("importado");
		Salida.Imprimirln("--contexto inicializado");
		
		// Sacar la ventana con el tema de usuario y contrasena
		
		String oo = JOptionPane.showInputDialog(this, "mensaje", "titulo", JOptionPane.QUESTION_MESSAGE);
		
		
		Salida.Imprimirln(oo);
		
		
		
		
/**		
		Importar imp = new Importar("garanda","libertad32");
//			Importar imp = new Importar("jaalonso","Wu_Wei_08");
		imp.importar();

//		Razonador.inicializar(Razonador.RCC5);
		Salida.Imprimirln("--FIN de la importacion");
		reiniciarContexto(null,null);
		Salida.Imprimirln("--grafico actualizado..");			
//			DummyPaella.getGUI().getAreaDibujo().repaint();
	*/		
	}
  
	public void menuGuardarComo() {
		
		Salida.Imprimirln("a guardar...");
		JFileChooser fileChooser = new JFileChooser() {
		
        @Override
        public void approveSelection() {
            File f = getSelectedFile();
            if(f.exists() && getDialogType() == SAVE_DIALOG) {
                int result = JOptionPane.showConfirmDialog(getTopLevelAncestor(),
                        "The selected file already exits. \n" +
                        "¿Overwrite?",
                        "Existing file.",
                        JOptionPane.YES_NO_CANCEL_OPTION,
                        JOptionPane.QUESTION_MESSAGE);
                switch(result)  {
                case JOptionPane.YES_OPTION:
                    super.approveSelection();
                    return;
                case JOptionPane.NO_OPTION:
                    return;
                case JOptionPane.CANCEL_OPTION:
                    cancelSelection();
                    return;
                }
            }
            super.approveSelection();
        }

		};
		
		
		fileChooser.setCurrentDirectory(new File("."));
			
		int retVal = fileChooser.showSaveDialog(this);
		if (retVal == JFileChooser.APPROVE_OPTION) {
			String fileName = fileChooser.getSelectedFile().getAbsolutePath();
			String extension = fileName.substring(
					fileName.lastIndexOf(".")+1, fileName.length());
			
			if (extension.equalsIgnoreCase("txt")) {
				Grabar.formatoTXT(fileName);

			} else if (extension.equalsIgnoreCase("cxt")) {
				Grabar.formatoCXT(fileName);
			} else {
				Salida.Imprimirln("Formato no soportado.");
			}
		}

	}

    
	public void menuExportarDel() {
		// TODO Auto-generated method stub
		
	}


	public void menuNuevo() {
		reiniciarContexto();
	}

	public boolean getSugerencias() {
		return biconos.sugerencia;
	}

    public abstract void botonEjecutarCambios(ListaElementos _nuevaconfig);    
	public abstract void cambioListaClases(ArrayList clases);
    public abstract void cambioListaIndividuos(ArrayList indivs);
    public abstract void cambioListaRelaciones();
    public abstract void cambioVentanaDibujo(ListaElementos _lista);
    public abstract void hacerSugerencias(ArrayList<String> clases);
    public abstract void reiniciarContexto();
    
    
    
    
    

    public ArrayList getListaRelaciones(){
    	return this.vrel.getSeleccion();
    }
    
    public void pintarRelacionesRCC(LinkedList lista){
    	
    	
    	
    	
    	this.vrel.actualizar(lista);

    	/***
    	 * HAY QUE AÑADIR: 
    	 *   - teniendo la lista de relaciones.. 
    	 *        que se calculen las regiones.
    	 */
    	
    	/////////////////////////////////////////////
    	
    	/***
    	 * Pintar las regiones.
    	 */
    	
    	
    	
    	
//    	this.vdibujo.actualizar(null);
    
    }
    
    public void pintarVentanaHistorial(LinkedList lista){
    	
    	//  <-------- incluir la lista dentro de la llamadas
    	
    	this.vhist.actualizar();
    }
    
    public void pintarVentanaDibujo(ListaElementos lista) {
    	this.vdibujo.actualizar(lista);
    }
    
    public void menuAcercade() {
    	System.out.println("Acerca de ... Gonzalo A. Aranda Corral");
    	
		JOptionPane.showMessageDialog(null,
				"About Paella tools...\n\n(c) Computational Logic Group. 2009",
				"About - Paella.",JOptionPane.INFORMATION_MESSAGE);

    }
    
    public void repintarDibujo() {
//    	AreaDibujo a = this.vdibujo.getDibujo();
//    	a.actualizar(null);
//    	a.repaint();
    	
    	this.vdibujo.getDibujo().repaint();
    	
    }
  
}
