package es.us.ccia.dummy.dibujo.ventanas;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.DefaultListModel;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;

import es.us.ccia.dummy.dibujo.GUI;
import es.us.ccia.dummy.dibujo.eventos.EventosClases;
import es.us.ccia.dummy.dibujo.eventos.EventosObjetos;


/***
 * 
 * @author  Gonzalo A. Aranda Corral
 * @version 0.1.0
 * @since   28/02/2009
 * @see
 *    20090228 Carga de las objetos 
 * 
 *
 */   

@SuppressWarnings({"serial","unchecked"})
public class VentanaObjetos extends JComponent {

	
	JList lista;
	DefaultListModel Lmodelo;
	JScrollPane panelInd;
    
	public VentanaObjetos (GUI g) {
		super();
		
		lista = new JList();
		lista.setCellRenderer(new IndividRenderer());
		Lmodelo = new DefaultListModel();
		lista.setModel(Lmodelo);
		
        lista.addListSelectionListener(new EventosObjetos(g));

		reiniciar(null);
        
    	panelInd = new JScrollPane(lista);
		
        setLayout(new BorderLayout());
        add(panelInd,BorderLayout.CENTER);
//        addIndividuo("individuos");

	}
	
	public void reiniciar(Collection lista) {
		
		if (lista != null) {

			Set orden = new TreeSet(); 
			
			Lmodelo.clear();
	
	    	for (Iterator i= lista.iterator();i.hasNext();) {
	    		ElementoLista cl = 
	    			new ElementoLista((i.next()).toString(),true);
	    		orden.add(cl);
	    	}
	    	
	    	Iterator i = orden.iterator();
	    	while (i.hasNext())
	    		Lmodelo.addElement(i.next());
	    	
	//    	lista.setSelectedValue(null, false);
		}

		
		
		
	}

	
	public ArrayList getSeleccion() {
		
		ArrayList devolver = new ArrayList();
		int tamano = lista.getSelectedIndices().length;
		
		for(int indice=0;indice<tamano;indice++) {
			devolver.add(lista.getSelectedValues()[indice].toString());
		}
		
		return devolver;
	}
	
	
	public void addIndividuo(String nombre) {
		ElementoLista cl = new ElementoLista(nombre,true);
		Lmodelo.addElement(cl);
	}

}

/***********************************************
 * 
 * 
 * @author garanda
 *
 */

@SuppressWarnings("serial")
class IndividRenderer extends JLabel implements ListCellRenderer {
 
private static final Color HIGHLIGHT_COLOR = new Color(0, 0, 128);

  public IndividRenderer() {
    setOpaque(true);
    setIconTextGap(12);
  }

  public Component getListCellRendererComponent(JList list, Object value,
      int index, boolean isSelected, boolean cellHasFocus) {
	  ElementoLista entry = (ElementoLista) value;
	  
//	  setIcon(Icons.getInstanceIcon());
	  setText(entry.getNombre());

	setBackground(Color.white);
	setForeground(Color.black);
    
    if (isSelected) {
			setBackground(HIGHLIGHT_COLOR);
			setForeground(Color.white);
			this.setFont(new Font("Default",Font.BOLD,12));
    } else {
		setBackground(Color.white);
		setForeground(Color.black);
		this.setFont(new Font("Default",Font.PLAIN,12));	
    	
    }
    return this;
  }
}
